.img.fmt.RGB32 <- 0x42475220
.img.fmt.RGB24 <- 0x42475218
.img.fmt.BGR32 <- 0x52474220
.img.fmt.BGR24 <- 0x52474218
.img.fmt.YV12  <- 842094169
.img.fmt.YUY2  <- 0x32595559

run.mplayer <- function(file) {
    system(paste("mplayer -nosound -vo dl:",system.file("libs",.Platform$r_arch,paste("videoTools",.Platform$dynlib.ext,sep=''),package="videoTools")," ",file,sep=''),wait=FALSE)
}

mplayer <- function(FUN, setup.FUN=NULL, format="RGB24", expand=TRUE, port=7922, save.env=NULL, frames=-1) {
    cat("start mplayer when ready:\nmplayer -nosound -vo dl:",system.file("libs",.Platform$r_arch,paste("videoTools",.Platform$dynlib.ext,sep=''),package="videoTools"),"\n",sep='')
    if (is.character(format)) format <- fourcc2int(format)
    s <- socketConnection(port=port,open="ab",server=TRUE)
    cat(" - mplayer connection established\n")
    first <- TRUE
    frame <- 1
    if (!is.null(save.env)) save.env$frame <- list()
    if (missing(FUN) || is.null(FUN)) FUN <- function(...) NULL
    if (is.null(setup.FUN)) setup.FUN <- function(...) NULL
    while (TRUE) {
        b <- readBin(s,"int",2)
        #cat(sprintf("%d (%d)\n", b[1], b[2]))
        if (b[1]==1) { # accept_format
            c <- readBin(s,"int",1)
            if (c==format) writeBin(65792L,s) else writeBin(131584L,s)
        }
        if (b[1]==2) { # dump_frame
            c <- readBin(s,"int",5);
            if (first) { first <- FALSE; w <- c[1]; h <- c[2]; if (!is.null(setup.FUN)) setup.FUN(c[1],c[2]) }
            ##cat(sprintf("  %08x %d %08x %d %d (remaining payload %d)\n", c[5], c[4], c[3], c[1], c[2], b[2]-20))
            r <- readBin(s,"raw", b[2]-20)
            if (c[3]==.img.fmt.RGB32 || c[3]==.img.fmt.RGB24 || c[3]==.img.fmt.BGR32 || c[3]==.img.fmt.BGR24) {
                l <- rawi2double(r,0,w*h*c[4],width=w,channels=c[4])
                if (!is.null(save.env)) save.env$frame[[frame]] <- l
                if (as.integer((c[5]/512)+0.2)%%2)
                    FUN(l[[3]],l[[2]],l[[1]])
                else
                    FUN(l[[1]],l[[2]],l[[3]])
            } else if (c[3]==.img.fmt.YV12) {
                if (expand)
                    FUN(raw2double(r,0,w*h,stride=w),
                        raw2double(r,w*h,w*h/4,stride=w/2,x.exp=2,y.exp=2)-0.5,
                        raw2double(r,w*h*2,w*h/4,stride=w/2,x.exp=2,y.exp=2)-0.5)
                else
                    FUN(raw2double(r,0,w*h,stride=w),
                        raw2double(r,w*h,w*h/4,stride=w/2)-0.5,
                        raw2double(r,w*h*2,w*h/4,stride=w/2)-0.5)
                if (!is.null(save.env)) {
                    if (expand)
                        save.env$frame[[frame]] <- list(raw2double(r,0,w*h,stride=w),
                                                        raw2double(r,w*h,w*h/4,stride=w/2,x.exp=2,y.exp=2)-0.5,
                                                        raw2double(r,w*h*2,w*h/4,stride=w/2,x.exp=2,y.exp=2)-0.5)
                    else
                        save.env$frame[[frame]] <- list(raw2double(r,0,w*h,stride=w),
                                                        raw2double(r,w*h,w*h/4,stride=w/2)-0.5,
                                                        raw2double(r,w*h*2,w*h/4,stride=w/2)-0.5)
                }
            } else if (c[3] ==.img.fmt.YUY2) {
                l <- rawi2double(r,0,w*h*c[4],width=w,channels=c[4])
                if (!is.null(save.env)) save.env$frame[[frame]] <- list(l[[1]],l[[2]]-0.5)
                FUN(l[[1]],l[[2]]-0.5)
            } else {
                FUN(r,w,h,c[3],c[4],c[5])
                if (!is.null(save.env)) save.env$frame[[frame]] <- list(data=r, width=w, height=h, format=c[3], channels=c[4], flags=c[5])
            }
            frame=frame+1
            if (frames>0 && frame>frames) break;
        }
        if (b[1]==3) break; # close
        if (b[1]==4) { # begin
            c=readBin(s,"int",3)
            if (first) { first=FALSE; w=c[1]; h=c[2]; setup.FUN(c[1],c[2]) }
        }
    }
    close(s)
    invisible(frame-1)
}
